/*
 * 消费记录
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class ConsumerOrdersController : BaseController
    {
        public ConsumerOrdersController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 消费记录列表

        /// <summary>
        /// 根据条件查询消费记录列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(ConsumerOrders data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 根据条件查询消费记录列表

        /// <summary>
        /// 消费记录列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(ConsumerOrders data, string MerchantIdSelect, string ConsumerIdNickName, string ConsumerIdMobile, string PayModeSelect, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("OrderNo", "1"); //订单号
            Fields.Add("SnNo", "1"); //SN号


            string condition = " and Status>-1";
            //商户
            if (!string.IsNullOrEmpty(MerchantIdSelect))
            {
                condition += " and MerchantId=" + MerchantIdSelect;
            }
            //消费者昵称
            if (!string.IsNullOrEmpty(ConsumerIdNickName))
            {
                condition += " and ConsumerId in (select ConsumerId from ConsumersForNickName where NickName='" + ConsumerIdNickName + "')";
            }
            //消费者手机号
            if (!string.IsNullOrEmpty(ConsumerIdMobile))
            {
                condition += " and ConsumerId in (select ConsumerId from ConsumersForMobile where Mobile='" + ConsumerIdMobile + "')";
            }
            //支付方式
            if (!string.IsNullOrEmpty(PayModeSelect))
            {
                condition += " and PayMode=" + PayModeSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("ConsumerOrders", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //商户
                dic["MerchantId"] = RelationClass.GetMerchantInfoInfo(int.Parse(dic["MerchantId"].ToString()));
                //消费者
                int ConsumerId = int.Parse(function.CheckInt(dic["ConsumerId"].ToString()));
                Consumers consumerid_Consumers = db.Consumers.FirstOrDefault(m => m.Id == ConsumerId) ?? new Consumers();
                dic["ConsumerIdNickName"] = consumerid_Consumers.NickName;
                dic["ConsumerIdMobile"] = consumerid_Consumers.Mobile;
                dic.Remove("ConsumerId");
                //支付方式
                int PayMode = int.Parse(dic["PayMode"].ToString());
                if (PayMode == 1) dic["PayMode"] = "支付宝";
                if (PayMode == 2) dic["PayMode"] = "微信";
                if (PayMode == 0) dic["PayMode"] = "";

            }
            return Json(obj);
        }

        #endregion

        #region 增加消费记录

        /// <summary>
        /// 增加或修改消费记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加消费记录

        /// <summary>
        /// 增加或修改消费记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(ConsumerOrders data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("ConsumerOrders", Fields, 0);
            AddSysLog(data.Id.ToString(), "ConsumerOrders", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改消费记录

        /// <summary>
        /// 增加或修改消费记录信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            ConsumerOrders editData = db.ConsumerOrders.FirstOrDefault(m => m.Id == Id) ?? new ConsumerOrders();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改消费记录

        /// <summary>
        /// 增加或修改消费记录信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(ConsumerOrders data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ConsumerOrders", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "ConsumerOrders", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除消费记录信息

        /// <summary>
        /// 删除消费记录信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "ConsumerOrders", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ConsumerOrders", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "ConsumerOrders", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ConsumerOrders", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "ConsumerOrders", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ConsumerOrders", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("ConsumerOrders", Sort, Id);

            AddSysLog(Id.ToString(), "ConsumerOrders", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.ConsumerOrders.Add(new ConsumerOrders()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "ConsumerOrders", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(ConsumerOrders data, string MerchantIdSelect, string ConsumerIdNickName, string ConsumerIdMobile, string PayModeSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("OrderNo", "1"); //订单号
            Fields.Add("SnNo", "1"); //SN号


            string condition = " and Status>-1";
            //商户
            if (!string.IsNullOrEmpty(MerchantIdSelect))
            {
                condition += " and MerchantId=" + MerchantIdSelect;
            }
            //消费者昵称
            if (!string.IsNullOrEmpty(ConsumerIdNickName))
            {
                condition += " and ConsumerId in (select ConsumerId from ConsumersForNickName where NickName='" + ConsumerIdNickName + "')";
            }
            //消费者手机号
            if (!string.IsNullOrEmpty(ConsumerIdMobile))
            {
                condition += " and ConsumerId in (select ConsumerId from ConsumersForMobile where Mobile='" + ConsumerIdMobile + "')";
            }
            //支付方式
            if (!string.IsNullOrEmpty(PayModeSelect))
            {
                condition += " and PayMode=" + PayModeSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("ConsumerOrders", Fields, "Id desc", "0", 1, 20000, condition, "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //商户
                dic["MerchantId"] = RelationClass.GetMerchantInfoInfo(int.Parse(dic["MerchantId"].ToString()));
                //消费者
                int ConsumerId = int.Parse(function.CheckInt(dic["ConsumerId"].ToString()));
                Consumers consumerid_Consumers = db.Consumers.FirstOrDefault(m => m.Id == ConsumerId) ?? new Consumers();
                dic["ConsumerIdNickName"] = consumerid_Consumers.NickName;
                dic["ConsumerIdMobile"] = consumerid_Consumers.Mobile;
                dic.Remove("ConsumerId");
                //支付方式
                int PayMode = int.Parse(dic["PayMode"].ToString());
                if (PayMode == 1) dic["PayMode"] = "支付宝";
                if (PayMode == 2) dic["PayMode"] = "微信";
                if (PayMode == 0) dic["PayMode"] = "";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "ConsumerOrders", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
